<?
//    -------------------------------------------------------------------------
//    $Id: Handler.php,v 1.2 2002/12/13 00:23:08 jonen Exp $
//    -------------------------------------------------------------------------
//    $Log: Handler.php,v $
//    Revision 1.2  2002/12/13 00:23:08  jonen
//    - removed $site_state vars
//      changes related to new Session class
//
//    Revision 1.1  2002/11/12 05:42:31  joko
//    + initial checkin
//
//    -------------------------------------------------------------------------


class Site_Handler {

  var $s = array();
  var $enc = array(
    map => array(),
    id => 70841,
    enabled => 0,
  );
  
  function _getid() {
    $this->enc[id]++;
    $dummyId = 's' . $this->enc[id];
    return $dummyId;
  }
  
  function setHandler($ident, $attribs) {
    //$this->site->log( get_class($this) . "->setHandler( ident $ident, attribs $attribs)", LOG_DEBUG );
    if (!is_array($attribs)) { $attribs = array(); }
    $newid = $this->_getid();
    // store handler
    $attribs[id] = $newid;
    $this->s[$ident] = $attribs;
    // create/store mapping
    $this->enc[map][$newid] = $ident;
  }
  
  function getHandler($ident) {
    if (count($this->s) == 0) {
      $this->site->log( get_class($this) . "->getHandler: called before any setHandler", LOG_WARNING );
    }
    return $this->s[$ident];
  }
  
  function getPageIdentifier() {
    //global $site_state;
    //return $site_state[page];
    return $this->site->session->get('page');
  }
  
  function checkIdentifier($ident) {
    return isset($this->s[$ident]);
  }

  function decodeIdentifier($arg) {
    if ($this->enc[enabled]) {
      $args = split('_', $arg);
      $ident_enc = array_shift($args);
      $ident = $this->enc[map][$ident_enc];
      array_unshift($args, $ident);
      $result = join('/', $args);
      return $result;
    } else {
      //$arg = str_replace('_', '/', $arg);
      return $arg;
    }
  }

  function encodeIdentifier($arg) {
    if ($this->enc[enabled]) {
      $result = $this->s[$arg][id];
      // strip action from arg, if present
      if (!$result && (substr($arg, -1) != '/') ) {
        $divpos = strrpos($arg, '/') + 1;
        $ident = substr($arg, 0, $divpos);
        $ident_enc = $this->s[$ident][id];
        $action = substr($arg, $divpos);
        $result = $ident_enc . '_' . $action;
      }
      return $result;
    } else {
      //$arg = str_replace('/', '_', $arg);
      return $arg;
    }
  }
  
}
?>