<?
//    -----------------------------------------------------------------
//    $Id: LocaleText.php,v 1.5 2002/12/19 10:30:06 joko Exp $
//    ------------------------------------------------------------------
//    $Log: LocaleText.php,v $
//    Revision 1.5  2002/12/19 10:30:06  joko
//    + argument 'newMode' for function getlt and function _getldsvar: let _getldsvar evaluate variable to still provide old behaviour/functionality
//
//    Revision 1.4  2002/12/19 06:18:40  joko
//    + '$this->site' gets used here now
//
//    Revision 1.3  2002/12/04 07:40:05  jonen
//    + comment out dprint
//
//    Revision 1.2  2002/12/03 03:10:21  joko
//    + bugfix regarding new object hierarchy
//
//    Revision 1.1  2002/11/12 05:42:30  joko
//    + initial checkin
//
//    Revision 1.9  2002/10/25 11:47:50  cvsmax
//    + modificate function getlt() to get variables in language related content work
//
//    Revision 1.8  2002/07/27 00:31:10  cvsjoko
//    *** empty log message ***
//
//    Revision 1.7  2002/07/19 18:17:30  cvsjoko
//    + changes for pre r0.01
//
//    Revision 1.6  2002/06/27 02:27:57  cvsjoko
//    + bugfix: couldn't use php-keywords as keys due to lack of quoting
//
//    Revision 1.5  2002/06/25 04:25:28  cvsjoko
//    + added error handling: load structure only if connection to db possible
//
//    Revision 1.4  2002/06/24 14:28:59  cvsmax
//    + bugfixing
//
//    Revision 1.3  2002/06/23 05:23:02  cvsmax
//    + add func 'user-session timeout' and extended (user) session logging
//
//    Revision 1.2  2002/06/19 18:16:14  cvsmax
//    + import to cvs
//
//    ------------------------------------------------------------------


class LocaleText {

  // current selected language
  var $langkey;
  
  // language-data-structure (hash)
  var $lds;
  
  // available languages
  var $langs_avail;
  
  // ----------------------------------------------------
  function LocaleText() {

    /*
    // was:
    global $cfg, $slt;
    session_register_safe('slt');
    $this->langs_avail = $cfg[GLBL_LANGSAVAIL];
    $this->load();
    */
    
    // look at the bottom of this file!!!
    //$smarty->register_block("translate", "do_translation");
    //$this->site->smarty->register_block("translate", "_do_translation");

    //global $site;
    //$site->smarty->register_block("translate", "_do_translation");

  }

  function start() {
    global $cfg, $slt;
    session_register_safe('slt');
    $this->langs_avail = $cfg[GLBL_LANGSAVAIL];
    $this->load();
  }

  // ----------------------------------------------------
  function _detectLanguage() {
    // detect language from Browser
    // HACK
    $browserLang = "tr";
    // if there is a browser-language set the current language to this one
    if ($browserLang) {
      // TODO: log this
      //print "- detecting browser-language: $browserLang<br>";
      return $browserLang;
    }
  }
  
  // ----------------------------------------------------
  function _findAvailableLanguage($newlang = "") {
    // check against available languages ...
    $langs_avail = $this->langs_avail;
    if (!( is_array($langs_avail) && count($langs_avail) > 0 )) {
      // TODO: log this
      print "error with multi-language-system, maybe \"GLBL_LANGSAVAIL\" is not properly configured?<br>";
      return;
    }
    if (in_array($newlang, $langs_avail)) {
      // ...  take the new one, if available, ...
      return $newlang;
    } else {
      // ... or take the first one as a default
      return $langs_avail[0];
    }
  }
  
  function _dbkey2ldskey($dbkey) {
    // TODO: log this
    //dprint("dbkey: $dbkey");
    //if (!$dbkey) { return; }
    if(substr($dbkey,0,1)=="/") { $dbkey=substr($dbkey,1); }
    $dbkey_arr = split('/', $dbkey);
    $ldskey = "['" . join("']['", $dbkey_arr) . "']";
    // return only if key is valid for php!!!
    if (!stristr($ldskey, '[]')) {
      return $ldskey;
    }
  }
  
  function _getldsvar($ldskey, $tpl=array(), $newMode = 0) {
    
//print "ldskey: $ldskey<br>";

    $var_name = '$this->lds' . $ldskey;
    $eval_string = "return $var_name;";
    //print $eval_string . "<br>";

    // interpolate variable-name
    $var_value = eval($eval_string);
    // interpolate variable-value to do some template-vars
    if (!$newMode) {
      $var_value = eval("return \"$var_value\";");
    }

    // V1 - result interpolation using eval
    // print $eval_string."<br>";
    //$var_value = $$var_name;

    // V2 - result interpolation using smarty
    //print Dumper($tpl);
    //$this->site->loadTemplate();

    return $var_value;
  }
  
  function _setldsvar($ldskey, $val) {
    $var_name = '$this->lds' . $ldskey;
    $value_new = addslashes($val);
    $eval_string = "$var_name = '$value_new';";
    //print $eval_string . "<br>";
    eval($eval_string);
    //$$var_name = $value_new;
  }
  
  function _loadStructure_FromDb() {
    //global $site;
    $this->site->log( get_class($this) . "->_loadStructure_FromDb loading language information", LOG_DEBUG);
    //print "- loading structure from db ($this->langkey)<br>";
    //connectdb();
    $sql = "SELECT * FROM td_res_langtext WHERE countrykey='" . $this->langkey . "'";
    if ($result = $this->site->db->query($sql)) {
      //while ($row = mysql_fetch_array($result,MYSQL_ASSOC)) {
      while ( $result->fetchInto($row) ) {
      	 //print $row[tval]."<br>";
      	 //print_r($row) . "<br>";
          $this->_loadStructure_FromDb_add($row["tkey"], $row["tval"]);
      }
    }
    $this->site->log( get_class($this) . "->_loadStructure_FromDb ready", LOG_DEBUG);
  }
  
  function _loadStructure_FromDb_add($dbkey, $val) {
    $ldskey = $this->_dbkey2ldskey($dbkey);
    $this->_setldsvar($ldskey, $val);
  }
  
  
  
  // ========================================

  function setLanguage($langkey_new = "") {
    global $slt;
    //print "setting lang<br>";
    if ($langkey_new) {
      $slt[langkey] = $langkey_new;
    }
    $this->load();
  }
  
  function load() {
    global $slt;

    if (!$this->langkey) { $this->langkey = $slt[langkey]; }
    if (!$this->langkey) { $this->langkey = $this->_findAvailableLanguage($slt[langkey]); }

    //print "- starting language-library<br>";
    //print "lang: " . $this->langkey . "<br>";
    //$langkey_new = $this->_detectLanguage();
    //$this->_loadStructure_FromDb();
    //$this->setLanguage($langkey_new);

    $this->_loadStructure_FromDb();
  }

  function getAvailableLanguages() {
    return $this->langs_avail;
  }

  function getCurrentLanguage() {
    return $this->langkey;
  }

  function getLangTexts() {
    return $this->lds;
  }
  
  function getlt($key, $tpl=array(), $newMode = 0) {
    //dprint("getlt: $key");
    if ($ldskey = $this->_dbkey2ldskey($key)) {
      return $this->_getldsvar($ldskey, $tpl, $newMode);
    }
  }

}



/*
Example 13-17. register_block
taken from: http://smarty.php.net/manual/en/api.register.block.html
will be triggered by this template-code:
  {* template *}
  {translate lang="br"}
     Hello, world!
  {/translate}
*/

  /* PHP */
  //global $smarty;
  //$smarty->register_block("translate", "do_translation");

/*  
  function _do_translation ($params, $content, &$smarty) {
      print "do_translation<br>";
      print "params: " . Dumper($params) . "<br>";
      print "content: $content<br>";
      if ($content) {
          //$lang = $params['lang'];
          // do some translation with $content
          //echo $translation;
          return getlt($content);
      }
  }
*/
  
?>